


#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <time.h>

uint16_t  p; // modulo
uint16_t  p_1; // -p¯¹

// Inverso mod 2^16
uint16_t inv2adic(uint16_t p)
{
  uint16_t i = p;
  uint16_t n;
  do
  {
    n = i * p;
    i *= (2 - n);
  } while(n != 1);
  return i;
}

// Montgomery core
uint16_t mont(uint16_t  a, uint16_t  b)
{
  uint32_t x = (uint32_t)a*(uint32_t)b;
  uint16_t y = (((x*p_1)&(65536-1))*p + x) >> 16;
  return y>=p ? y-p : y;  
}

int main(int argc, char **argv)
{
  uint16_t a, b;
  p = 21; // Modulo
  p_1 = -inv2adic(p); // -p¯1 (mod p) 

  srand(time(NULL));

  a = rand() % p; // a e b
  b = rand() % p; // aleatorios

  /*
   * Converter para Montgomery: aR (mod p) <=> mont(a, R² mod p) => aR²R¯¹ = aR (mod p)
   * Converter para Fp: Mont(aR, 1) => aRR¯¹ => a
  */
  printf("%u * %u mod %u = %u (%u)\n", a, b, p, mont(mont((a*65536) % 21,(b*65536)%21), 1), (a*b) % p);
  return 0;
}


